#!/usr/bin/python
# coding=utf-8
# Author: zsr
#
# 定时监测 更新配置文件 启动检测程序
import datetime
import socket
import urllib
import urllib2
import json
import os
import download_thread
import execute_thread
import ConfigParser as configparser
import sys
server_conf_file = os.path.abspath(os.path.join(os.path.dirname(__file__), "..")) + "/config/server.conf"
local_conf_file = os.path.abspath(os.path.join(os.path.dirname(__file__), "..")) + "/threshold/local.json"
local_app_dir = os.path.abspath(os.path.join(os.path.dirname(__file__), "..")) + "/app/"
def getLocalConfig():
    # 读取本地配置文件
    cp = configparser.ConfigParser()
    cp.read(server_conf_file)
    return cp


def setLocalVersion(remote,download_result):
    for result in  download_result:
        if result.flag == False:
            return
    with open(local_conf_file, 'w') as json_file:
        json_file.write(json.dumps(remote, sort_keys=True, indent=4, separators=(',', ':')))


def getLocalVersion(detectionNum):
    try:
        if len(os.listdir(local_app_dir)) < detectionNum:
            return []
        with open(local_conf_file, 'r') as json_file:
            load_dict = json.load(json_file)
            return load_dict
    except Exception as e:
        return []


def updateCheckFile(cp):
    # 发送http 请求 获取检测项
    try:
        url = cp.get("server", "host") + cp.get("server", "check") + getHostIp()
        result = urllib2.urlopen(url).read()
        jr = json.loads(result, encoding="utf8")
        if jr['code'] != 200:
            print("未配置检测项")
        else:
            detectionList =  jr['data']['data']
            return detectionList
    except Exception as e:
        return []

# 比较远程和本地检测项情况
def compareDetection(remote, local):
    detection_remote = {}
    detection_local = {}
    task_array = []
    for de in remote:
        detection_remote[de["detectionId"]] = de
    for de in local:
        detection_local[de["detectionId"]] = de
    for detectionId in detection_remote.keys():
        dec_local =  detection_local.get(detectionId)
        dec_remote = detection_remote.get(detectionId)
        if dec_local == None or (dec_remote.get("version")!=dec_local.get("version")):
           task_array.append(dec_remote)
    return  task_array

def getHostIp():
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    s.connect(('8.8.8.8', 80))
    ip = s.getsockname()[0]
    return ip

def winPidAlive(pid):
    process_info = os.popen('wmic process where "processID=%s" get CommandLine'%(str(pid)),'r').read()
    return process_info.find("heartbeat.py") != -1

def uploadLogInfo(result_array, cp):
    url = cp.get("server", "host") + cp.get("server", "upload")
    data = urllib.urlencode({'info': json.dumps(result_array)})
    req = urllib2.Request(url)
    opener = urllib2.build_opener(urllib2.HTTPCookieProcessor())
    response = opener.open(req, data).read()

if __name__ == '__main__':
    nowTime = datetime.datetime.now()

    #心跳检测保活检测
    if sys.platform.find("linux") != -1:
        heartNum = int(os.popen("ps -ef|grep /home/monitor4/client/core/heartbeat.py | grep -v grep|wc -l").read())
        if heartNum==0:
            os.system("python /home/monitor4/client/core/heartbeat.py &")
        elif heartNum > 1:
            os.system("ps -ef | grep /home/monitor4/client/core/heartbeat.py | grep -v grep | awk '{print $2}' | xargs kill -9")
            os.system("python /home/monitor4/client/core/heartbeat.py &")
        else:
            pass
    else:  # windows
        import subprocess
        heartbeatPidPath = os.path.abspath(os.path.join(os.path.dirname(__file__), "..")) + "/config/pid.info"
        heartbeatPid = 0
        with open(heartbeatPidPath, 'r') as f:
            heartbeatPid = f.read()
        if int(heartbeatPid) == 0 or (not winPidAlive(heartbeatPid)):
            subprocess.Popen(r"python C:\monitor4\client\core\heartbeat.py",shell=True)
    # 获取本地配置
    gcp = getLocalConfig()
    # print("-- getLocalConfig --")

    #获取远程检测项列表
    remote_array = updateCheckFile(gcp)
    print("-- updateCheckFile --")

    # 获取本地检测项列表
    load_array = getLocalVersion(len(remote_array))
    print("-- getLocalVersion --")

    # 远程检测项和本地不一致
    if remote_array != load_array:
        task_array = compareDetection(remote_array,load_array)
        download_result = download_thread.downloadTask(task_array, gcp)
        # print("-- downloadTask --")
        setLocalVersion(remote_array,download_result)
        # print("-- setLocalVersion --")
        print("-- download and save -- ")

    # 并发执行所有检测脚本并组装返回结果
    execute_array = execute_thread.executeTask(load_array, getHostIp())
    print("-- executeTask --")

    # 上传结果记录日志
    #print execute_array
    uploadLogInfo(execute_array, gcp)
    print("-- uploadLogInfo --")
